<template>
  <div>
    <div class="text-body1 q-px-md q-pb-sm">
      <translate>Nutrient balance</translate>
    </div>
    <div class="row justify-between q-px-md q-mb-sm">
      <q-toggle
        v-model="showDetailedNutrientBalance"
        size="xs"
        dense
      >
        <span class="text-caption text-grey">
          <translate>Show the full balance</translate>
        </span>
      </q-toggle>

      <FertilizationResultDisplaySettingsButton :algorithm-id="algorithmId" />
    </div>

    <template v-if="showBasicNutrientBalance">
      <NutrientBalanceItem
        :npk-elements="recommendationNpkElements"
        :label="$gettext('Recommendation')"
      />
    </template>

    <template v-else>
      <q-expansion-item
        header-class="q-pa-none"
        expand-icon-class="expand-toggle"
        class="result-expansion"
      >
        <template #header>
          <q-item-section>
            <NutrientBalanceItem
              :npk-elements="inputsNpkElements"
              :label="$gettext('Inputs')"
            />
          </q-item-section>
        </template>

        <q-card class="bg-grey-2">
          <q-card-section class="q-pa-none">
            <NutrientBalanceItem
              :npk-elements="inSoiInitiallNpkElements"
              :label="$gettext('In soil before sowing')"
              deemphasize
              class="result-no-expansion"
            />
            <NutrientBalanceItem
              :npk-elements="biologicalFixationNpkElements"
              :label="$gettext('Biological fixation')"
              deemphasize
              class="result-no-expansion"
            />
            <NutrientBalanceItem
              :npk-elements="soilMineralizationdNpkElements"
              :label="$gettext('Soil mineralization')"
              deemphasize
              class="result-no-expansion"
            />
            <NutrientBalanceItem
              :npk-elements="irrigationNpkElements"
              :label="$gettext('Irrigation')"
              deemphasize
              class="result-no-expansion"
            />
            <NutrientBalanceItem
              :npk-elements="plannedNpkElements"
              :label="$gettext('Planned fertilization')"
              deemphasize
              class="result-no-expansion"
            />
          </q-card-section>
        </q-card>
      </q-expansion-item>

      <q-expansion-item
        header-class="q-pa-none"
        expand-icon-class="expand-toggle"
        class="result-expansion"
      >
        <template #header>
          <q-item-section>
            <NutrientBalanceItem
              :npk-elements="outputsNpkElements"
              :label="$gettext('Outputs')"
            />
          </q-item-section>
        </template>

        <q-card class="bg-grey-2">
          <q-card-section class="q-pa-none">
            <NutrientBalanceItem
              :npk-elements="inSoiFinalNpkElements"
              :label="$gettext('In soil after harvesting')"
              deemphasize
              class="result-no-expansion"
            />
            <NutrientBalanceItem
              :npk-elements="leachingNpkElements"
              :label="$gettext('Leaching')"
              deemphasize
              class="result-no-expansion"
            />
            <NutrientBalanceItem
              :npk-elements="uptakeNpkElements"
              :label="$gettext('Crop uptake')"
              deemphasize
              class="result-no-expansion"
            />
            <NutrientBalanceItem
              :npk-elements="denitrificationNpkElements"
              :label="$gettext('Denitrification')"
              deemphasize
              class="result-no-expansion"
            />
            <NutrientBalanceItem
              :npk-elements="volatilizationNpkElements"
              :label="$gettext('Volatilization')"
              deemphasize
              class="result-no-expansion"
            />
          </q-card-section>
        </q-card>
      </q-expansion-item>

      <q-separator inset />

      <NutrientBalanceItem
        :npk-elements="balanceNpkElements"
        :label="$gettext('Balance')"
        class="result-no-expansion"
      />
    </template>

    <div class="text-caption text-grey q-ml-md q-mt-sm">
      <translate>All numbers in</translate><span class="q-ml-xs">{{ displayUnit }}</span>
    </div>
  </div>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import NutrientBalanceItem from 'src/pages/fieldbook/fertilization/algorithms/common/components/NutrientBalanceItem'
import FertilizationResultDisplaySettingsButton from 'src/pages/fieldbook/fertilization/algorithms/common/components/FertilizationResultDisplaySettingsButton'
import { resultTypes, getDisplayUnit, convertResults } from 'src/services/fieldbook/fertilization/fertilizationPlan'
import { NAVIGATOR_F3 } from 'src/services/fieldbook/fertilization/algorithms'

export default {
  name: 'NavigatorF3NutrientBalance',
  mixins: [PlatformMixin],
  components: {
    NutrientBalanceItem,
    FertilizationResultDisplaySettingsButton
  },
  props: {
    balanceItems: {
      type: Array,
      required: true
    },
    displayUnitConfig: {
      type: Object,
      default: null
    }
  },
  computed: {
    showBasicNutrientBalance () {
      return !this.showDetailedNutrientBalance
    },
    showDetailedNutrientBalance: {
      get () {
        return this.$store.state.appState.showDetailedNutrientBalance
      },
      set (v) {
        this.$store.commit('appState/setShowDetailedNutrientBalance', v)
      }
    },
    recommendationNpkElements () {
      return this.getNpkElements(resultTypes.RECOMMENDATION)
    },
    inputsNpkElements () {
      return this.getNpkElements(resultTypes.INPUTS)
    },
    outputsNpkElements () {
      return this.getNpkElements(resultTypes.OUTPUTS)
    },
    balanceNpkElements () {
      return this.getNpkElements(resultTypes.BALANCE)
    },
    inSoiInitiallNpkElements () {
      return this.getNpkElements(resultTypes.IN_SOIL_INITIAL)
    },
    biologicalFixationNpkElements () {
      return this.getNpkElements(resultTypes.BIOLOGICAL_FIXATION)
    },
    soilMineralizationdNpkElements () {
      return this.getNpkElements(resultTypes.SOIL_MINERALIZATION)
    },
    irrigationNpkElements () {
      return this.getNpkElements(resultTypes.IRRIGATION)
    },
    plannedNpkElements () {
      return this.getNpkElements(resultTypes.PLANNED)
    },
    inSoiFinalNpkElements () {
      return this.getNpkElements(resultTypes.IN_SOIL_FINAL)
    },
    leachingNpkElements () {
      return this.getNpkElements(resultTypes.LEACHING)
    },
    uptakeNpkElements () {
      return this.getNpkElements(resultTypes.UPTAKE)
    },
    denitrificationNpkElements () {
      return this.getNpkElements(resultTypes.DENITRIFICATION)
    },
    volatilizationNpkElements () {
      return this.getNpkElements(resultTypes.VOLATILIZATION)
    },
    displayUnit () {
      return getDisplayUnit(this.displayUnitConfig)
    },
    algorithmId () {
      return NAVIGATOR_F3
    }
  },
  methods: {
    getNpkElements (resultType) {
      return convertResults(this.balanceItems.filter(recommendation => recommendation.result_type === resultType), this.displayUnitConfig)
    }
  }
}
</script>

<style scoped>
.result-expansion :deep(.expand-toggle) {
  padding-left: 0;
  padding-right: 16px
}
.result-no-expansion {
  padding-right: 40px;
}
</style>
